<template>
	<div style="padding-bottom: 10px;">
		<SpinnerHolder class="loader" v-if="loading" :background="false"></SpinnerHolder>
		<BlankLayout class="command">
			<template slot="head">
				<CommonHeader :showBackButton="hideButtons" :title="$t('deliveryAddress')"></CommonHeader>
			</template>
			<template slot="body">
				<div class="wrapper">
					<div class="two">
						<h3 v-text="nameRestaurant"></h3>
					</div>
				</div>
				<div class="addDirrection" @click="goLocation">
					<div>
						<p><i class="fa fa-map-marker"></i>  {{$t('deliver')}} </p>
						<span v-if="!addressDefault">{{$t('addAddress')}} </span>
						<span v-else>{{address}} </span>
					</div>
					<span>&#8250;</span>
				</div>
				<ul>
					<li class="block">
						<input type="checkbox" name="item" id="item1" checked />
						<label for="item1">
							<i aria-hidden="true" class="icon-users"></i>
							{{ $t('yourOrder') }}
							<button @click="backToMenu()" class="btn-backToMenu" v-show="hideButtons">
								{{ $t('backToMenu') }}
							</button>
							<span>&#8249;</span>
						</label>
						<ul class="options">
							<li v-for="(item, index) of order.items" :key="index">
								<div class="items-container">
									<div class="item">
										<Thumbnail
											class="thumbnail"
											:style="thumbnailBorder"
											:src="item.photoURL"
										></Thumbnail>
										<div class="item-info">
											<span
												>{{ item.localizedName }}
												<span style="font-size: 14px">({{ item.quantity }})</span></span
											>
											<span class="small-details">{{ item.details }}</span>
											<span
												class="small-details"
												:set="(wantedIngredients = item.ingredients.filter(i => i.selected))"
												>{{
													wantedIngredients.length
														? reduceIngredients(wantedIngredients, $t('with'))
														: ''
												}}</span
											>
										</div>
										<h2 class="number">
											{{
												formatPrice(
													(item.price.ammount + item.priceIngredients) * item.quantity,
													true
												)
											}}
										</h2>
									</div>
								</div>
							</li>
						</ul>
					</li>
				</ul>
				<div class="content-delivery" style="background-color: rgb(243, 243, 243)">
					<b class="title"> {{ $t('delivery') }}</b>
					<span class="cost">{{ formatPrice(order.deliveryCost) + ' MXN' }}</span>
					<br/>
					<b><span class="tip">{{ 'Propina no incluida' }}</span></b>
				</div>
				<div class="content-delivery total">
					<b class="title">{{ $t('total') }}</b
					><span class="cost">{{ totaltext }}</span
					><br />
					<span class="sub-title">{{ $t('taxes') }}</span>
					<br />
				</div>

				<div class="layout">
					<input
						name="nav"
						type="radio"
						class="nav home-radio"
						id="onlinePayment"
						:checked="checkedTabs"
						v-model="methodPayment"
						v-bind:value="'ONLINE'"
						@change="show('ONLINE')"
						@click="loadStripe()"
					/>
					<div class="page home-page">
						<div class="page-contents">
							<div class="container-pago">
								<div class="metodo">
									<div class="container-metodos">
										<div
											v-show="
												paymentActive && conektaActive && onlinePaymentActive && conektaReady
											"
										>
											<label class="container" style="height: 50px;"
												>{{ $t('PaymentCard') }}
												<img class="card" src="../assets/img/cards.png" />
											</label>
											<div
												class="container-methodpay-info-card"
												id="div1"
												v-show="displayDivCard"
											>
												<div>
													<div>
														<div
															class="container-methodpay-info-card"
															id="div1"
															v-show="displayDivCard"
														>
															<span v-if="!conektaReady || !stripeReady" class="error">{{
																$t('methodPaymentError')
															}}</span>
															<div
																id="card-element"
																class="container-methodpay-info-card"
															></div>
															<span v-if="!cardData" class="error">{{
																$t('missingData')
															}}</span>
														</div>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<label
						class="nav"
						v-show="paymentActive && conektaActive && onlinePaymentActive"
						for="onlinePayment"
					>
						<span> {{ $t('onlinePayment') }} </span>
					</label>
					<input
						name="nav"
						type="radio"
						class="contact-radio"
						id="cashPayment"
						:checked="!checkedTabs"
						v-model="methodPayment"
						v-bind:value="'CASH'"
						@change="show('CASH')"
					/>
					<div class="page contact-page">
						<div class="page-contents">
							<div class="metodo" v-show="hideButtons">
								<div class="container-metodos">
									<div v-show="cashActive">
										<div class="container-methodpay-info" id="div2" v-show="displayDivCash">
											<p>{{ $t('infoCash') }}</p>
											<input class="bee-input" type="text" v-model="cashInfo" />
											<span v-if="cashInfoError" class="error">{{ $t('cashInfoError') }}</span>
											<span v-if="excessCash" class="error">{{ $t('excessCash') }}</span>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<label class="nav" for="cashPayment">
						<span> {{ $t('cashPayment') }} </span>
					</label>
				</div>

				<div class="send-container">
					<BeeInput
						class="send-button"
						:class="{ disabled: order.items.length == 0 }"
						@click="displayDoubleConfirm()"
						v-show="hideButtons">
						<b>{{ order && order.sent && !order.id ? $t('retryPay') : `${$t('pay')} ${formatPrice(order.total, true)}`}}</b>
					</BeeInput>
					<DoubleConfirmFinishOrder
						v-show="showDoubleConfirm"
						@click="displayThanks()"
						@close="showDoubleConfirm = !showDoubleConfirm"
					></DoubleConfirmFinishOrder>
					<ThankYouOrderModal v-show="showThanks" @close="showThanks = !showThanks"></ThankYouOrderModal>
				</div>
				<div>
					<BeeInput @click="backToMenu()" class="btn-backToMenu" v-show="!hideButtons">
						{{ $t('backToMenu') }}
					</BeeInput>
				</div>
				<Modal v-if="!openRestaurant || !hideModal" @close="hideForm()">
					<div class="send-form">
						<div class="form-group">
							<span
								v-if="!openRestaurant || !messageToPurchaser"
								class="label"
								style="color: red; font-weight: bold;"
								>{{ $t('deliverystatusMessage') }}</span
							>
							<span v-else class="label" style="color: red; font-weight: bold;">{{
								$t(messageToPurchaser)
							}}</span>
						</div>
					</div>
				</Modal>
				<Snackbar :text="$t('verifyLocation')" :active="true"></Snackbar>
				<Snackbar v-if="withoutAddress" :text="$t('addAnAddress')" :active="true"></Snackbar>
			</template>
		</BlankLayout>
	</div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import Background from '@/components/Background.vue'
import VariableLogo from '@/components/VariableLogo.vue'
import Snackbar from '@/components/Snackbar.vue'
import Menu from '@/models/Menu'
import Thumbnail from '@/components/Thumbnail.vue'
import BeeInput from '@/components/BeeInput.vue'
import WhatsApp from '@/components/WhatsAppButtom.vue'
import BlankLayout from '@/layouts/BlankLayout.vue'
import AjaxButton from '@/components/AjaxButton.vue'
import CounterButton from '@/components/CounterButton.vue'
import Modal from '@/components/Modal.vue'
import Order, { PaymentMethod, StatusDelivery } from '../models/Order'
import ItemIngredient from '../models/ItemIngredient'
import VueQrcode from '@chenfengyuan/vue-qrcode'
import { DeliveryMenu, Payments, Schedule } from '@/models/DeliveryMenu'
import ThankYouOrderModal from '@/components/ThankYouOrderModal.vue'
import DoubleConfirmFinishOrder from '@/components/DoubleConfirmFinishOrder.vue'
import Localization from '@/models/Localization'
import { formatPrice } from '@/mixins/MenuLocalization'
import OrderService from '@/services/OrderService'
import { TypePayment } from '@/models/TypePayment'
import axios from 'axios'
import { User } from '../models/User'
import { PaymentDetails, PaymentStatus } from '@/models/PaymentDetails'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import auth from '@/config/auth'
import Customer from '@/models/PaymentGateway/Customer'
import { isOpen } from '@/utils/ScheduleUtils'
import { Stripe, loadStripe, StripeCardElement } from '@stripe/stripe-js'
import { ApiErrors } from '@/models/PaymentGateway/ApiErrors'
import AddressService from '@/services/AddressService'
import AddressBook from '@/models/AddressBook'
import { TypeOrder } from '@/store/state'
import firebase from 'firebase'
import { getDeliveryCost } from '@/utils/MapsUtils'

@Component({
	components: {
		CommonHeader,
		VariableLogo,
		Background,
		Thumbnail,
		CounterButton,
		BeeInput,
		Modal,
		AjaxButton,
		VueQrcode,
		WhatsApp,
		BlankLayout,
		ThankYouOrderModal,
		DoubleConfirmFinishOrder,
		SpinnerHolder,
		Snackbar
	}
})
export default class SummaryDelivery extends Vue {
	name = ''
	phone = ''
	date = ''
	hour = ''
	address = ''
	methodPayment = ''
	cashInfo = ''
	totaltext = ''
	cashInfoError = false
	excessCash = false
	visa = false
	deliveryCost = 0
	americanExpress = false
	mastercard = false
	cardActive = false
	cashActive = false
	onlineActive = false
	transferActive = false
	onlinePaymentActive = this.$store.state.deliveryMenu.onlinePayment
	paymentActive = this.$store.state.deliveryMenu.payment.online.active
	conektaActive = this.$store.state.deliveryMenu.payment.online.conekta
	nameRestaurant = ''
	dateNow = new Date()
	modalForm = false
	displayDivCard = false
	displayDivCash = true
	displayDivTransfer = false
	displayDivConketa = false
	hideButtons = true
	showWhats = true
	order: Order | null = this.$store.state.order
	menu: Menu | null = this.$store.state.menu
	thumbnailBorder = `border: 1px ${this.$store.getters.colors.backgroundColor} solid;`
	goodEnding = false
	loading = false
	delivery: DeliveryMenu = this.$store.state.deliveryMenu
	openRestaurant = true
	hideModal = true
	schedule: Schedule | undefined = undefined
	scheduleInitDay = ''
	scheduleEndDay = ''
	showThanks = false
	showDoubleConfirm = false
	deliveryEstimate = ''
	user: User | null = this.$store.state.user
	checkedTabs = false
	cardDetails: { cardName: string; cardNumber: string; cardExpiry: string; cardCvc: string } = {
		cardName: '',
		cardNumber: '',
		cardExpiry: '',
		cardCvc: ''
	}
	cardErrors: { cardName: boolean; cardNumber: boolean; cardExpiry: boolean; cardCvc: boolean } = {
		cardName: false,
		cardNumber: false,
		cardExpiry: false,
		cardCvc: false
	}
	messageToPurchaser = ''
	customer: Customer | undefined = undefined
	token = ''
	conektaReady = true
	stripeReady = true
	processingPayment = false
	stripe: Stripe | null = null
	completeForm = false
	cardData = true
	cardElement: StripeCardElement | null = null
	addressDefault = false
	addressDefaultData: AddressBook | undefined = undefined
	withoutAddress = false
	canOrder = false

	goLocation() {
		this.$router.push('/locations')
	}

	get orderSent() {
		if (this.order && this.order.sent) return true
		return false
	}

	get readableId() {
		if (this.order?.number) {
			return '#' + this.order.number
		}
		return ''
	}

	hideForm() {
		this.hideModal = true
		const active = this.$store.state.deliveryMenu.shipping
		if (active === false || !this.openRestaurant) {
			this.$router.push(`/${this.menu?.restaurantId}/${this.menu?.id}`)
		}
	}

	async displayDoubleConfirm() {
		this.loading = true
		if (this.order && this.addressDefault){
			if (this.methodPayment === PaymentMethod.CASH) {
				if(this.cashInfo != ''){
					if (this.order.total > 2000) {
						this.excessCash = true
						this.cashInfoError = false
						this.loading = false
					} else {
						this.showDoubleConfirm = true
						this.loading = false
					}
				}else{
					this.cashInfoError = true
					this.loading = false
				}
			}
			if (this.methodPayment === PaymentMethod.ONLINE) {
				if (this.completeForm) {
					this.cardData = true
					await this.getStripePaymentMethod()
				} else {
					this.cardData = false
					this.loading = false
				}
			}
		}else{
			this.loading = false
			this.withoutAddress = true
		}
	}

	async displayThanks() {
		const delivery: DeliveryMenu | undefined = this.$store.state.deliveryMenu
		if (delivery) {
			if (delivery.schedule) {
				this.schedule = delivery.schedule
			}

			if (this.menu) {
				this.loading = true
				this.openRestaurant = await isOpen(this.menu.id)
				this.loading = false
			}
		}
		if (this.openRestaurant) {
			this.showDoubleConfirm = false
			this.showThanks = true
			setTimeout(() => {
				this.closeShowThanks()
			}, 1500)
		} else {
			this.openRestaurant = false
			this.loading = false
		}
	}

	closeShowThanks() {
		this.showThanks = false
		this.sendForm()
	}

	onlyNumber($event) {
		const keyCode = $event.keyCode ? $event.keyCode : $event.which
		if (keyCode < 48 || keyCode > 57) {
			$event.preventDefault()
		}
	}

	monthYear($event) {
		const keyCode = $event.keyCode ? $event.keyCode : $event.which
		if (keyCode < 48 || keyCode > 57) {
			$event.preventDefault()
		}
	}

	async sendForm() {
		if (!this.showThanks) {
			if (!this.order) return
			this.loading = true
			switch (this.methodPayment) {
				case PaymentMethod.CASH:
					{
						if (this.cashInfo != '') {
							this.order.payment = PaymentMethod.CASH
							this.order.cash = this.cashInfo
							const paymentDetails = new PaymentDetails()
							paymentDetails.status = PaymentStatus.PENDING_PAYMENT
							paymentDetails.amount = this.order.subtotal + this.order.deliveryCost
							paymentDetails.type = TypePayment.CASH
							this.order.paymentDetails = { ...paymentDetails }
							this.$store.state.order.statusDelivery = StatusDelivery.FINISHED
						} else {
							this.cashInfoError = true
						}
					}
					break
				case PaymentMethod.ONLINE:
					{
						this.order.payment = PaymentMethod.ONLINE
						this.$store.state.order.statusDelivery = StatusDelivery.FINISHED
					}
					break
			}
			const orderId = await OrderService.sendOrder(this.order, '', this.order.type, this.order.deliveryCost)
			if (orderId) {
				switch (this.methodPayment) {
					case PaymentMethod.ONLINE:
						{
							try {
								if (auth.currentUser) {
									const body = {
										orderId: orderId,
										cardId: this.token
									}
									const options = {
										headers: {
											Authorization: await auth.currentUser.getIdToken(true)
										}
									}
									const resp = await axios.post(
										`${process.env.VUE_APP_PAYMENT_USER}/api/v1/payment/stripe/order`,
										body,
										options
									)
									if (
										resp.data &&
										resp.data.paymentDetails &&
										resp.data.paymentDetails.status === 'SUCCEEDED'
									) {
										this.order.id = resp.data.id
										this.$store.commit('setOrder', this.order)
										this.$analytics.logEvent('purchase', {
											value: this.order.subtotal + this.order.deliveryCost,
											currency: this.order.currency,
											transaction_id: this.order.id,
											shipping: this.order.deliveryCost,
											payment_type: 'Online',
											items: this.order.items.map(item => ({
												item_id: item.id,
												item_name: item.name,
												quantity: item.quantity,
												price: Number(item.price),
												item_category: item.category,
												item_category2: item.subcategory,
												item_brand: this.$store.state.menu.name,
												affiliation: this.$store.state.typeOrder
											}))
										})
										this.$router.push('/SummaryDeliveryConfirm')
									}
								}
							} catch (e) {
								this.messageToPurchaser = ApiErrors.NOT_FINALIZED
								this.showDoubleConfirm = false
								this.hideModal = false
							}
						}
						break
					case PaymentMethod.CASH:
						{
							this.$store.commit('setOrder', this.order)
							this.$router.push('/SummaryDeliveryConfirm')
							this.$analytics.logEvent('purchase', {
								value: this.order.subtotal + this.order.deliveryCost,
								currency: this.order.currency,
								transaction_id: this.order.id,
								shipping: this.order.deliveryCost,
								payment_type: 'Cash',
								items: this.order.items.map(item => ({
									item_id: item.id,
									item_name: item.name,
									quantity: item.quantity,
									price: Number(item.price),
									item_category: item.category,
									item_category2: item.subcategory,
									item_brand: this.$store.state.menu.name,
									affiliation: this.$store.state.typeOrder
								}))
							})
						}
						break
				}
			}
			this.loading = false
		}
	}

	show(option: string) {
		switch (option) {
			case 'CASH':
				this.displayDivCash = true
				this.displayDivTransfer = false
				this.displayDivCard = false
				this.displayDivConketa = false
				break
			case 'ONLINE':
				this.displayDivCash = false
				this.displayDivTransfer = false
				this.displayDivCard = true
				break
			default:
				break
		}
	}

	reduceIngredients(ingredients: Array<ItemIngredient>, start: string) {
		return ingredients.reduce(
			(p, i, index, array) =>
				p +
				i.localizedNames +
				': ' +
				i.extraIngredients.map(rest => {
					if (rest.selected == true) return ' ' + rest.localizedNames
				}) +
				`${index + 1 == array.length ? '' : ', ' + start + ' '}`,
			start + ' '
		)
	}

	changeAddress() {
		this.$router.push('/maps')
	}

	backToMenu() {
		this.$router.push('/menu')
	}

	async created() {
		this.loading = true
		const request = await AddressService.getAllAddressBook()
		if(request){
			const data = request.data
			data.forEach(a => {
				if(a.defaultAddress){
					this.address = a.formatAddress
					this.addressDefault = true
					this.$store.state.order.address = a
					this.$store.state.order.address.location = new firebase.firestore.GeoPoint(a.location.lat, a.location.lng)
				}
			});
		}
		this.canOrder = await this.calculateDeliveryCost()
		if (this.user && this.order){
			this.order.userId = this.user.id
			this.order.name = this.user.name
			this.order.email = this.user.email
			this.order.phone = this.user.phone
			this.order.type = TypeOrder.DELIVERY
			this.order.statusDelivery = StatusDelivery.SUMMARY
			this.order.number = OrderService.generateReadableId()
			this.order.status = 'PENDING'
		} 
		if (this.order && !this.order.items.some(item => item.type == 'PRODUCT')) this.backToMenu()

		this.nameRestaurant = this.$store.state.menu.name
		this.getInfoOrder()
		this.getTotal()

		if (this.order) this.order.total = this.order.subtotal + this.order.deliveryCost
		if (this.paymentActive && this.conektaActive && this.onlinePaymentActive) {
			this.checkedTabs = true
			this.loadStripe()
			this.methodPayment = 'ONLINE'
			this.show('ONLINE')
		} else {
			this.methodPayment = 'CASH'
			this.show('CASH')
			this.checkedTabs = false
		}
		this.$store.commit('setOrder', this.order)
		this.loading = false
	}

	async calculateDeliveryCost(){
		let locationUser = new firebase.firestore.GeoPoint(0,0)
		const data = this.$store.state.order
		if(data.address){
			locationUser = this.$store.state.order.address.location
		}else {
			locationUser = this.$store.state.deliveryMenu.location
		}
		const locationCatalog = this.$store.state.deliveryMenu.location
		return getDeliveryCost(locationUser, locationCatalog)
	}

	async successTokenHandler() {
		if (auth.currentUser) {
			try {
				const body = {
					tokenId: this.token
				}
				const options = {
					headers: {
						Authorization: await auth.currentUser.getIdToken(true)
					}
				}
				const resp = await axios.post(
					`${process.env.VUE_APP_PAYMENT_USER}/api/v1/payment/stripe/card`,
					body,
					options
				)
				if (resp.data && resp.data.id) {
					if (this.order) {
						this.$analytics.logEvent('add_payment_info', {
							currency: this.order.currency,
							payment_type: 'Stripe',
							value: this.order.subtotal + this.order.deliveryCost,
							items: this.order.items.map(item => ({
								item_id: item.id,
								item_name: item.name,
								quantity: item.quantity,
								price: Number(item.price),
								item_category: item.category,
								item_category2: item.subcategory,
								item_brand: this.$store.state.menu.name,
								affiliation: this.$store.state.typeOrder
							}))
						})
					}
					this.token = resp.data.id
					this.loading = false
					this.showDoubleConfirm = true
				}
			} catch (error) {
				const data = error.response.data
				const message = data.errors.shift().trim()
				if (Object.values(ApiErrors).includes(message)) {
					const match = Object.entries(ApiErrors).find(([key, value]) => value === message)
					if (match) {
						const [key] = match
						this.messageToPurchaser = ApiErrors[key]
					} else {
						this.messageToPurchaser = ApiErrors.NOT_FINALIZED
					}
				}
				this.showDoubleConfirm = false
				this.hideModal = false
			}
		}
	}

	errorTokenHandler(errorMessage: string) {
		if (this.order) {
			this.$analytics.logEvent('add_payment_info_error', {
				currency: this.order.currency,
				error_message: errorMessage,
				payment_type: 'Stripe',
				value: this.order.subtotal + this.order.deliveryCost,
				items: this.order.items.map(item => ({
					item_id: item.id,
					item_name: item.name,
					quantity: item.quantity,
					price: Number(item.price),
					item_category: item.category,
					item_category2: item.subcategory,
					item_brand: this.$store.state.menu.name,
					affiliation: this.$store.state.typeOrder
				}))
			})
		}
		this.messageToPurchaser = errorMessage
		this.hideModal = false
		this.loading = false
	}

	async loadStripeScript() {
		const lang = this.$store.state.language === 'spanish' ? 'es-419' : 'en'
		if (!this.stripe)
			this.stripe = await loadStripe(process.env.VUE_APP_STRIPE_PUBLIC_KEY || '', {
				locale: lang
			})
	}

	async getStripePaymentMethod() {
		if (this.stripe) {
			if (this.cardElement) {
				const result = await this.stripe.createPaymentMethod({
					type: 'card',
					card: this.cardElement
				})

				if (result.paymentMethod && result.paymentMethod.id) {
					this.token = result.paymentMethod.id
					this.successTokenHandler()
				} else {
					if (result.error && result.error.message) this.errorTokenHandler(result.error.message)
				}
			}
		}
	}

	async loadStripe() {
		await this.loadStripeScript()
		if (auth.currentUser && this.stripe) {
			const options = {
				headers: {
					Authorization: await auth.currentUser.getIdToken(true)
				}
			}
			try {
				const user = await axios.get(`${process.env.VUE_APP_PAYMENT_USER}/api/v1/payment/stripe`, options)
				if (user.data && user.data.id) {
					const data = user.data
					this.customer = new Customer(data?.id, data?.name, data?.email, data?.object, data?.createdAt)
				}
			} catch {
				const newUser = await axios.post(
					`${process.env.VUE_APP_PAYMENT_USER}/api/v1/payment/stripe`,
					{},
					options
				)
				if (newUser.data && newUser.data.id) {
					const data = newUser.data
					this.customer = new Customer(data?.id, data?.name, data?.email, data?.object, data?.createdAt)
				} else {
					this.stripeReady = false
				}
			}
			if (!this.cardElement) {
				this.cardElement = this.stripe.elements().create('card')
				this.cardElement.mount('#card-element')
				this.cardElement.on('change', evt => {
					this.completeForm = evt.complete
				})
			}
		} else {
			this.stripeReady = false
		}
	}

	getInfoOrder() {
		const payments = this.$store.state.deliveryMenu.payment as Payments
		payments.cash ? (this.cashActive = true) : (this.cashActive = false)
		payments.online.active ? (this.onlineActive = true) : (this.onlineActive = false)
	}

	getTotal() {
		if (this.order) {
			if (this.$store.state.currency == 'MXN') {
				const total: number = this.order.subtotal + this.order.deliveryCost
				this.totaltext = `${formatPrice(total)} MXN`
			} else {
				let total: number = this.order.subtotal
				const delivery: number = this.order.deliveryCost
				const localizations = this.$store.state.menu.localizations
				localizations.forEach((docLocalization: Localization) => {
					if (docLocalization.currency == this.$store.state.currency) {
						total = total * parseInt(docLocalization.change) + delivery
						this.totaltext = `${formatPrice(total)} MXN`
					}
				})
			}
		} else {
			this.totaltext = ''
		}
	}
}
</script>

<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}
.command {
	display: flex;
	flex-direction: column;
	background-color: rgb(255, 255, 255);
	color: rgb(14, 14, 14);
	width: 100%;
	height: 100%;

	.wrapper {
		margin-left: 18px;
		height: 40px;
		display: grid;
		grid-template-columns: repeat(12, 1fr);
		grid-gap: 10px;
		grid-auto-rows: minmax(100px, auto);
	}
	.two {
		width: 250px;
		height: 70px;
	}
	ul {
		list-style: none;
		//margin:0;
		padding: 0;
		width: 100%;
		margin: 0 auto;

		.block {
			.btn-backToMenu {
				background-color: transparent;
				border: transparent;
				color: rgb(53, 57, 255);
			}
			.options {
				li {
					.items-container {
						.item {
							margin-bottom: 20px;
							display: flex;
							width: 100%;
							justify-content: space-between;
							align-items: center;

							.thumbnail {
								width: 60px;
								height: 60px;
								border-radius: 50%;
								margin-left: 15px;
							}

							.item-info {
								display: flex;
								flex-direction: column;
								max-width: 150px;
								margin-right: auto;
								margin-left: 10px;
								font-family: 'Roboto Condensed';
								.name {
									color: #000000;
									font-size: 16px;
									line-height: 19px;
								}
								.small-details {
									font-size: 10px;
								}

								.quantity {
									margin-top: 8px;
									color: #646979;
									font-size: 18px;
									line-height: 21px;
								}
							}
							.counter {
								margin-right: 15px;
							}
							.number {
								color: #feca38;
								margin-right: 10px;
							}
						}
					}
				}
			}
		}
	}
	.container-pago {
		background: #fafafa;
		border: 1px solid #c0c0c0;
		border-radius: 4px;
	}
	ul li label {
		color: rgb(0, 0, 0);
		font-weight: 600;
	}
	ul li input[type='checkbox'] {
		display: none;
	}
	ul li label {
		display: block;
		padding: 12px;
		width: 100% !important;
	}
	ul li i {
		font-size: 18px;
		vertical-align: middle;
		width: 20px;
	}
	ul li label {
		background: rgb(243, 243, 243);
	}
	ul li input[type='checkbox']:checked ~ label {
		background: rgb(221, 221, 221);
	}
	ul li input[type='checkbox']:checked ~ .options {
		height: auto;
		display: block;
		min-height: 40px;
	}
	ul li label span {
		float: right;
		font-size: 25px;
		font-weight: 900;
		-webkit-transform: rotate(-90deg);
		-moz-transform: rotate(-90deg);
		-ms-transform: rotate(-90deg);
		-o-transform: rotate(-90deg);
		transform: rotate(-90deg);
		display: inline-block;
		vertical-align: middle;
	}
	ul li input[type='checkbox']:checked ~ label span {
		-webkit-transform: rotate(90deg);
		-moz-transform: rotate(90deg);
		-ms-transform: rotate(90deg);
		-o-transform: rotate(90deg);
		transform: rotate(90deg);
		display: inline-block;
	}
	ul ul {
		background: #fff;
		margin: 0;
		padding: 0;
	}
	ul ul li {
		border-bottom: 1px solid #ccc;
	}
	ul ul li:first-child {
		padding-top: 6px;
	}
	ul ul li:last-child {
		padding-bottom: 6px;
		border: 0;
	}
	.options {
		height: 0;
		display: block;
		overflow: hidden;
	}
	.confirm {
		padding: 10px;
	}
	.metodo {
		// padding: 10px;
		.title {
			font-size: 20px;
			font-weight: 700;
		}
		.sub-title {
			font-size: 13px;
			color: rgb(160, 160, 160);
		}
		.container-metodos {
			.container {
				.card {
					// margin-right: 15px;
					float: right;
					width: 100px;
					height: auto;
				}
			}
		}
		.container-methodpay-info-card {
			background-color: #fafafa;
			padding: 0.8em;
		}
		.container-methodpay-info {
			background: rgba(254, 202, 56, 0.1);
			border: 1px solid #feca38;
			border-radius: 8px;
			padding: 4px;
			p {
				font-family: 'Roboto Condensed';
				font-size: 16px;
				margin: 5px 2px;
				color: gray;
			}
			.bee-input {
				font-size: 16px;
			}
		}
	}
	.form-group {
		display: grid;
		margin: 1em 0;
		// color: transparent;
		background-color: transparent;
		i {
			position: absolute;
			right: 0px;
			padding: 12px 30px;
			pointer-events: none;
		}

		input {
			border-radius: 4px;
			border: 0.5px solid rgba(192, 192, 192, 1);
			padding: 0.8em 0.8em 0.8em 10px;
		}
		input::-webkit-input-placeholder {
			color: rgba(117, 112, 112, 1);
			font-size: 1.2em;
		}
	}
	.send-container {
		width: 100%;
		padding: 0.5em;
		background: #ffffff;
		box-shadow: 0px -1px 41px rgba(0, 0, 0, 0.15);
		position: fixed;
		bottom: 0px;
		.send-button {
			margin: auto;
			width: 90%;
			height: 50px;
			font-size: 18px;
		}

		.disabled {
			//background-color: #d8d8d8 !important;
			visibility: hidden;
		}
	}

	.btn-wa {
		z-index: 3000;
		margin: 5% auto;
		position: fixed;
		right: 3%;
	}

	.content-delivery > total {
		background-color: #feca38;
	}

	.content-delivery {
		padding: 10px 10px 10px 10px;
		.title {
			font-size: 18px;
		}
		.cost {
			font-size: 23px;
			font-weight: 800;
			color: #feca38;
			display: block;
			float: right;
		}
		.sub-title {
			color: rgb(139, 139, 139);
			font-size: 14px;
			letter-spacing: 0.5px;
		}
		.tip {
			font-weight: bold;
			font-size: 15px;
			color: rgb(104, 104, 104);
		}
	}
	.noReembolsosDevoluciones {
		font-size: 10px;
		margin-top: 0.8em;
		margin-left: 2em;
	}
}

.container {
	display: block;
	position: relative;
	padding: 1em 2.5em;
	cursor: pointer;
	-webkit-user-select: none;
	-moz-user-select: none;
	-ms-user-select: none;
	user-select: none;
	background: #ffffff;
	border-radius: 4px 4px 0px 0px;
}

.container input {
	position: absolute;
	opacity: 0;
	cursor: pointer;
}

/* Create a custom radio button */
.checkmark {
	position: absolute;
	left: 3px;
	height: 25px;
	width: 25px;
	background-color: #eee;
	border-radius: 50%;
}

.container:hover input ~ .checkmark {
	background-color: #ccc;
}

.container input:checked ~ .checkmark {
	background-color: rgb(254, 202, 56);
}

.checkmark:after {
	content: '';
	position: absolute;
	display: none;
}

.container input:checked ~ .checkmark:after {
	display: block;
}

.container .checkmark:after {
	top: 9px;
	left: 9px;
	width: 8px;
	height: 8px;
	border-radius: 50%;
	background: white;
}

.error {
	display: contents;
	text-align: left;
	font-size: 12px;
	color: red;
	margin: auto;
}

.layout {
	display: grid;
	width: 100%;
	overflow: hidden;
	grid-template-rows: 50px 1fr;
	grid-template-columns: 1fr 1fr;
	padding-bottom: 60px;
}

input[type='radio'] {
	display: none;
}

label.nav {
	display: flex;
	align-items: center;
	justify-content: center;
	cursor: pointer;
	color: rgba(0, 0, 0, 0.54);
	user-select: none;
	transition: background 0.4s, padding-left 0.2s;
	padding-left: 0;
	input[type='radio']:checked + .page + & {
		font-size: 16px;
		font-weight: 600;
		color: #f2c94c;
		border-bottom: 2px solid #f2c94c;
		padding-left: 20px;
		span {
			padding-left: 20px;
		}
	}
	span {
		padding-left: 0px;
		position: relative;
		text-transform: uppercase;
	}
}

.page {
	grid-column-start: 1;
	grid-row-start: 2;
	grid-column-end: span 3;
	padding: 0px 20px;
	display: flex;
}

.page-contents > * {
	opacity: 0;
	transform: translateY(20px);
	transition: opacity 0.2s, transform 0.2s;
	@for $c from 1 through 20 {
		&:nth-child(#{$c}) {
			transition-delay: 0.2s + ($c * 0.2s);
		}
	}
}

input[type='radio'] + .page {
	transition: transform 0.2s;
	transform: translateX(100%);
}

input[type='radio']:checked + .page {
	transform: translateX(0%);
	.page-contents > * {
		opacity: 1;
		transform: translateY(0px);
	}
}

.page-contents {
	max-width: 100%;
	width: 500px;
	margin: 0.5em auto;
}

@media (min-width: 960px) {
	.two {
		grid-column: 2 / 12 !important;
	}
}

.send-form {
	color: black;
	font-family: 'Roboto Condensed';
	.form-group {
		margin: 10px;
		text-align: center;
	}
}

.addDirrection {
	p {
		font-weight: bold;
		font-size: 16px;
		line-height: 19px;
		margin: 0.5em 0;
	}
	display: flex;
	justify-content: space-between;
	align-items: flex-end;
	padding: 0.8em;
	margin: 1em;
	background: #ffffff;
	box-shadow: 0px 1px 4px rgba(0, 0, 0, 0.25);
	border-radius: 7px;
	span {
		font-weight: 600;
		font-size: 1.5em;
		color: #000000;
	}
	div {
		span {
			font-style: normal;
			font-weight: normal;
			font-size: 14px;
			line-height: 24px;
		}
	}
}
</style>
